<template>
  <div class="container-fluid dimensions-details-wrapper">
    <div class="row dimensions-details-content h-100">
      <div class="col-md-9 p-md-5 details-body">
        <h1
          class="title font-weight-bold mb-4"
        >
          <span
            :class="`primary-color-${attributes.className}`"
          >
            {{ $t(`message.dashboard.${dimension}.title`) }}
          </span>
        </h1>

        <p class="mb-4">
          {{ $t(`message.dashboard.${dimension}.description`) }}
        </p>
        <!-- Graphs container -->
        <div
          class="d-flex flex-wrap"
        >
          <div v-if="!metrics || metrics.length === 0">
            {{ $t("message.no_data") }}
          </div>
          <div
            v-else
            v-for="(value, key) in metrics"
            :key="`${dimension}:${key}`"
            class="graph-container position-relative"
            :class="attributes.indicators[key].graphType"
          >
            <component
              v-if="metrics[key] && metrics[key].length > 0"
              :is="attributes.indicators[key].graphType"
              :width="200"
              :height="attributes.indicators[key].graphType === 'line-chart' ? 400 : 200"
              :title="$t(`message.dashboard.${dimension}.plots.title.${key}`)"
              :chart-data="metrics[key].map(el => el.percentage)"
              :chart-labels="metrics[key].map(el => el.name)"
              :chart-background-colors="attributes.chartStyle.backgroundColors"
            ></component>
            <div v-else class="d-flex flex-column justify-content-center align-items-center px-2">
              <div class="pt-2 pb-2 text-center" style="height:100%;font-size:12px;font-weight:bold;color:#666666;">
                {{ $t(`message.dashboard.${dimension}.plots.title.${key}`) }}
              </div>
              <div class="font-weight-light text-center">
                {{ $t("message.no_data") }}
              </div>
            </div>
          </div>
        </div>
      </div>
      <!-- Sidebar -->
      <div class="col-md-3 pl-0 border-right sidebar order-first">
        <nav class="pt-md-5 pr-md-5 pl-md-5 sidebar-content">
          <ul class="nav d-flex flex-column">
            <!-- eslint-disable vue/no-unused-vars -->
            <li
              class="sidebar-nav-element mb-1 mb-md-2"
              v-for="({label, className}, identifier) in dimensionsAttributes"
              :key="identifier"
            >
              <router-link
                :class="`primary-color-${attributes.className}`"
                :active-class="`sidebar-nav-link-active text-white primary-bg-color-${className}`"
                class="btn sidebar-nav-link pt-2 pb-2"
                :to="{ name: dimensionsType, params: {dimension: identifier} }"
              >
                {{ $t(`message.dashboard.${identifier}.title`) }}
              </router-link>
            </li>
          </ul>
        </nav>
      </div>
    </div>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import DoughnutChart from './graphs/DoughnutChart'
import BarChart from './graphs/BarChart'
import LineChart from './graphs/LineChart'
import dimensionsAttributes from './utils/dimensions-attributes'

export default {
  name: 'DimensionsDetails',
  components: {
    DoughnutChart,
    BarChart,
    LineChart
  },
  data () {
    return {
      name: this.$route.params.name,
      dimensionsAttributes,
      loaded: false
    }
  },
  props: {
    dimensionsType: {
      type: String,
      required: true,
      default () {
        return 'dimensions-details'
      }
    }
  },
  computed: {
    ...mapGetters({
      storeMetrics: 'metrics'
    }),
    getMetrics () {
      return this.storeMetrics
    },
    dimension () {
      return this.$route.params.dimension
    },
    metrics () {
      const dimension = this.$route.params.dimension
      return this.getMetrics ? this.getMetrics[dimension] : []
    },
    attributes () {
      return this.dimensionsAttributes[this.dimension]
    }
  },
  async created () {
  },
  methods: {
    graphType (indicator) {
      return this.attributes.indicators[indicator].graphType
    }
  }
}
</script>

<style lang="scss" scoped>
@import "../../styles/metrics-style.scss";
@import "~bootstrap/scss/bootstrap";

.dimensions-details-wrapper {
  max-height: 100%;
  height: 100vh;
  overflow: auto;

  .sidebar {
    background-color: $gray-lightest;
  }

  @include media-breakpoint-up(md) {
    .sidebar {
      height: 100%;
    }
  }
}

@include media-breakpoint-up(md) {
  .dimensions-details-wrapper {
    max-height: 100%;
    height: 100vh;
  }
}

@include media-breakpoint-up(lg) {
  .dimensions-details-wrapper {
    max-height: 656px;
    height: 90vh;
  }
}

.title { font-size: 2.5rem; }
.graph-container {
  height: 25%;
  width: 100%;
  .no-data-container {
    min-width: 200px;
    height: 200px;
  }
  &.line-chart {
    width: 100% !important;
  }
}

@include media-breakpoint-up(sm) {
  .graph-container {
    height: 25%;
    width: 50%
  }
}

@include media-breakpoint-up(lg) {
  .graph-container {
    height: 25%;
    width: 25%
  }
}

@media (min-width: 576px) {
    .title { font-size: 2.5rem; }
}
@media (min-width: 768px) {
    .title { font-size: 3.25rem; }
}
@media (min-width: 992px) {
    .title { font-size: 4.5rem; }
}
@media (min-width: 1200px) {
    .title { font-size: 4.5rem; }
}

.details-body {
  // Prozent Text Doughnut
  .absolute-center {
    position: absolute;
    top: 55%;
    left: 50%;
    transform: translate(-50%, -50%);
    z-index: -30; //z achse nach hinten gerückt, damit die Hover der Diagramme besser sichtbarer sind.
  }

  .pulse {
    display: block;
    width: 22px;
    height: 22px;
    border-radius: 50%;
    background: $primary;
    cursor: pointer;
    box-shadow: 0 0 0 $primary;
    animation: pulse 2s infinite;
  }

  @-webkit-keyframes pulse {
    0% {
      -webkit-box-shadow: 0 0 0 0 $primary;
    }
    70% {
        -webkit-box-shadow: 0 0 0 10px rgba(204,169,44, 0);
    }
    100% {
        -webkit-box-shadow: 0 0 0 0 rgba(204,169,44, 0);
    }
  }
  @keyframes pulse {
    0% {
      -moz-box-shadow: 0 0 0 0 $primary;
      box-shadow: 0 0 0 0 $primary;
    }
    70% {
        -moz-box-shadow: 0 0 0 10px rgba(204,169,44, 0);
        box-shadow: 0 0 0 10px rgba(204,169,44, 0);
    }
    100% {
        -moz-box-shadow: 0 0 0 0 rgba(204,169,44, 0);
        box-shadow: 0 0 0 0 rgba(204,169,44, 0);
    }
  }
}

.sidebar {
  .sidebar-nav-link {
    font-size: 1.1rem;
  }

  .sidebar-nav-link  {
    &:hover {
      text-decoration: underline;
    }
    &.sidebar-nav-link-active {
      color: white;
      font-weight: 400;
      &:hover {
        text-decoration: none!important;
      }
    }
  }
}

.primary-bg-color-accessibility {
  background-color: $edp-logo-blue;
}

.primary-bg-color-findability {
  background-color: $edp-logo-light-blue;
}

.primary-bg-color-interoperability {
  background-color: $edp-logo-dark-blue;
}

.primary-bg-color-reusability {
  background-color: $edp-logo-orange;
}

.primary-bg-color-contextual {
  background-color: $edp-logo-yellow;
}

.primary-bg-color-scoring {
  background-color: $edp-logo-black;
}

.primary-color-accessibility {
  color: $edp-logo-blue;
}

.primary-color-findability {
  color: $edp-logo-light-blue;
}

.primary-color-interoperability {
  color: $edp-logo-dark-blue;
}

.primary-color-reusability {
  color: $edp-logo-orange;
}

.primary-color-contextual {
  color: $edp-logo-yellow;
}

.primary-color-scoring {
  color: $edp-logo-black;
}

</style>
